<?php
namespace Teknisa\SM\Service;

use Teknisa\SM\Factory\Sm00004005ParamFaturaContratoFactory;
use Teknisa\Libs\Util\Environment;

class Sm00004005ParamFaturaContratoService {
    
    protected $RelacElementoFactory;
    protected $Environment;
    
    public function __construct (Sm00004005ParamFaturaContratoFactory $ParamFaturaContratoFactory, Environment $Environment){
        $this->ParamFaturaContratoFactory  = $ParamFaturaContratoFactory;
        $this->Environment  = $Environment;
    }
    
    /**
     * A função "insereDadosContrato" insere os dados de parametização 
     * de fatiuramento na tabela de Contrato (FCT_CONTRATO).
     */
    public function insereDadosContrato($idFaturaContr, $cdModPgto, $qtParcelasFatu, $nrDiaVencParcelasFatu, $dtInicFatContr, $idQtDiasCompCon, $nrQtDiasCompCon, $idCompetCont, $nrDiaCompetCont, $idTpDtEmissNf, $nrDiaDtEmissNf, $idTpDtVenc, $nrDiaVenParcFat, $idTpFatuIncomp, $seqContrato){
    
        $paramsInsereDadosContr = array(
            "IDFATURACONTR" => $idFaturaContr,
            "CDMODPGTO" => $cdModPgto,
            "QTPARCELASFATU" => $qtParcelasFatu,
            "NRDIAVENCPARCELASFATU" => $nrDiaVencParcelasFatu,
            "DTINICFATCONTR"  => $dtInicFatContr,
            "IDQTDIASCOMPCON" => $idQtDiasCompCon,
            "NRQTDIASCOMPCON" => $nrQtDiasCompCon,
            "IDTPCOMPETCONT"  => $idCompetCont,
            "NRDIACOMPETCONT" => $nrDiaCompetCont,
            "IDTPDTEMISSNF"   => $idTpDtEmissNf,
            "NRDIADTEMISSNF"  => $nrDiaDtEmissNf,
            "IDTPDTVENC"      => $idTpDtVenc,
            "NRDIAVENPARCFAT" => $nrDiaVenParcFat,
            "IDTPFATUINCOMP"  => $idTpFatuIncomp,
            "NRSEQCONTRATO"   => $seqContrato,
            "NRORG"           => $this->Environment->getNrOrg()
        );
        
        $this->ParamFaturaContratoFactory->insereDadosContrato($paramsInsereDadosContr);
    }
    
     /**
      * Retorna os produto de faturamento do serviço
     */
    public function getDadosModeloContrato($nrseqmodcontra, $nrorg){
        $params = array(
            "NRSEQMODCONTRA" => $nrseqmodcontra,
            "NRORG"      => $nrorg
        );

        $result = $this->ParamFaturaContratoFactory->getDadosModeloContrato($params);
        return isset($result) ? $result : null;
    }
}

?>